diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/block-ack-manager.h ns-3.44/src/wifi/model/block-ack-manager.h
--- ns-3.43/src/wifi/model/block-ack-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/block-ack-manager.h	2025-03-09 16:55:49.783372600 -0700
@@ -466,12 +650,12 @@
      * queues (independently of the status) if the MPDU is not stored in the EDCA
      * queue, is an old packet or its lifetime expired.
      *
-     * \param linkId the ID of the link on which the MPDU has been transmitted
-     * \param mpduIt an iterator pointing to the MPDU in the queue of in flight MPDUs
-     * \param status the status of the in flight MPDU
-     * \param it iterator pointing to the Block Ack agreement
-     * \param now the current time
-     * \return an iterator pointing to the next MPDU in the queue of in flight MPDUs
+     * @param linkId the ID of the link on which the MPDU has been transmitted
+     * @param mpduIt an iterator pointing to the MPDU in the queue of in flight MPDUs
+     * @param status the status of the in flight MPDU
+     * @param it iterator pointing to the Block Ack agreement
+     * @param now the current time
+     * @return an iterator pointing to the next MPDU in the queue of in flight MPDUs
      */
     PacketQueueI HandleInFlightMpdu(uint8_t linkId,
                                     PacketQueueI mpduIt,
@@ -480,6 +664,17 @@
                                     const Time& now);
 
     /**
+     * Handle discarded MPDU by making the transmit window advance beyond the discarded frame.
+     * This also involves (i) the removal of frames that consequently become old from the
+     * retransmit queue and from the queue of the block ack agreement, and (ii) the
+     * scheduling of a BlockAckRequest.
+     *
+     * @param mpdu the discarded MPDU
+     * @param iter an iterator to the corresponding agreement
+     */
+    void HandleDiscardedMpdu(Ptr<const WifiMpdu> mpdu, OriginatorAgreementsI iter);
+
+    /**
      * This data structure contains, for each originator block ack agreement (recipient, TID),
      * a set of packets for which an ack by block ack is requested.
      * Every packet or fragment indicated as correctly received in BlockAck frame is
@@ -491,9 +686,14 @@
     std::list<AgreementKey> m_sendBarIfDataQueued; ///< list of BA agreements for which a BAR shall
                                                    ///< only be sent if data is queued
 
+    /// List of received GCR BlockAck frames indexed by originator
+    using GcrBlockAcks = std::map<Mac48Address, CtrlBAckResponseHeader>;
+    std::map<Mac48Address /* GCR group address */, GcrBlockAcks>
+        m_gcrBlockAcks; ///< received GCR Block ACKs
+
     uint8_t m_blockAckThreshold; ///< block ack threshold
     Ptr<WifiMacQueue> m_queue;   ///< queue
-    Callback<void, Mac48Address, uint8_t, bool>
+    Callback<void, Mac48Address, uint8_t, bool, std::optional<Mac48Address>>
         m_blockAckInactivityTimeout;                      ///< BlockAck inactivity timeout callback
     Callback<void, Mac48Address, uint8_t> m_blockPackets; ///< block packets callback
     Callback<void, Mac48Address, uint8_t> m_unblockPackets; ///< unblock packets callback
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/block-ack-type.cc ns-3.44/src/wifi/model/block-ack-type.cc
--- ns-3.43/src/wifi/model/block-ack-type.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/block-ack-type.cc	2025-03-09 16:55:49.783372600 -0700
@@ -23,6 +23,7 @@
         break;
     case COMPRESSED:
     case EXTENDED_COMPRESSED:
+    case GCR:
         m_bitmapLen.push_back(8);
         break;
     case MULTI_TID:
@@ -53,6 +54,7 @@
     case BASIC:
     case COMPRESSED:
     case EXTENDED_COMPRESSED:
+    case GCR:
         m_nSeqControls = 1;
         break;
     case MULTI_TID:
@@ -91,6 +93,9 @@
     case BlockAckType::MULTI_TID:
         os << "multi-tid-block-ack[" << type.m_bitmapLen.size() << "]";
         break;
+    case BlockAckType::GCR:
+        os << "gcr-block-ack";
+        break;
     case BlockAckType::MULTI_STA:
         os << "multi-sta-block-ack[" << type.m_bitmapLen.size() << "]";
         break;
@@ -117,6 +122,9 @@
     case BlockAckReqType::MULTI_TID:
         os << "multi-tid-block-ack-req[" << type.m_nSeqControls << "]";
         break;
+    case BlockAckReqType::GCR:
+        os << "gcr-block-ack-req";
+        break;
     default:
         NS_FATAL_ERROR("Unknown block ack request type");
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/block-ack-type.h ns-3.44/src/wifi/model/block-ack-type.h
--- ns-3.43/src/wifi/model/block-ack-type.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/block-ack-type.h	2025-03-09 16:55:49.783372600 -0700
@@ -17,21 +17,22 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * The different BlockAck variants.
  */
 struct BlockAckType
 {
     /**
-     * \enum Variant
-     * \brief The BlockAck variants
+     * @enum Variant
+     * @brief The BlockAck variants
      */
-    enum Variant
+    enum Variant : uint8_t
     {
         BASIC,
         COMPRESSED,
         EXTENDED_COMPRESSED,
         MULTI_TID,
+        GCR,
         MULTI_STA
     };
 
@@ -45,35 +46,36 @@
     /**
      * Constructor for BlockAckType with given variant.
      *
-     * \param v the Block Ack variant
+     * @param v the Block Ack variant
      */
     BlockAckType(Variant v);
     /**
      * Constructor for BlockAckType with given variant
      * and bitmap length.
      *
-     * \param v the Block Ack variant
-     * \param l the length (bytes) of included bitmaps
+     * @param v the Block Ack variant
+     * @param l the length (bytes) of included bitmaps
      */
     BlockAckType(Variant v, std::vector<uint8_t> l);
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * The different BlockAckRequest variants.
  */
 struct BlockAckReqType
 {
     /**
-     * \enum Variant
-     * \brief The BlockAckReq variants
+     * @enum Variant
+     * @brief The BlockAckReq variants
      */
-    enum Variant
+    enum Variant : uint8_t
     {
         BASIC,
         COMPRESSED,
         EXTENDED_COMPRESSED,
-        MULTI_TID
+        MULTI_TID,
+        GCR
     };
 
     Variant m_variant;      //!< Block Ack Request variant
@@ -87,15 +89,15 @@
     /**
      * Constructor for BlockAckReqType with given variant.
      *
-     * \param v the Block Ack Request variant
+     * @param v the Block Ack Request variant
      */
     BlockAckReqType(Variant v);
     /**
      * Constructor for BlockAckReqType with given variant
      * and number of SSC fields.
      *
-     * \param v the Block Ack Request variant
-     * \param nSeqControls the number of included Starting Sequence Control fields
+     * @param v the Block Ack Request variant
+     * @param nSeqControls the number of included Starting Sequence Control fields
      */
     BlockAckReqType(Variant v, uint8_t nSeqControls);
 };
@@ -103,18 +105,18 @@
 /**
  * Serialize BlockAckType to ostream in a human-readable form.
  *
- * \param os std::ostream
- * \param type block ack type
- * \return std::ostream
+ * @param os std::ostream
+ * @param type block ack type
+ * @return std::ostream
  */
 std::ostream& operator<<(std::ostream& os, const BlockAckType& type);
 
 /**
  * Serialize BlockAckReqType to ostream in a human-readable form.
  *
- * \param os std::ostream
- * \param type block ack request type
- * \return std::ostream
+ * @param os std::ostream
+ * @param type block ack request type
+ * @return std::ostream
  */
 std::ostream& operator<<(std::ostream& os, const BlockAckReqType& type);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/block-ack-window.h ns-3.44/src/wifi/model/block-ack-window.h
--- ns-3.43/src/wifi/model/block-ack-window.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/block-ack-window.h	2025-03-09 16:55:49.783372600 -0700
@@ -16,8 +16,8 @@
 {
 
 /**
- * \ingroup wifi
- * \brief Block ack window
+ * @ingroup wifi
+ * @brief Block ack window
  *
  * This class provides the basic functionalities of a window sliding over a
  * bitmap: accessing any element in the bitmap and moving the window forward
@@ -53,33 +53,33 @@
     /**
      * Initialize the window with the given starting sequence number and size
      *
-     * \param winStart the window start
-     * \param winSize the window size
+     * @param winStart the window start
+     * @param winSize the window size
      */
     void Init(uint16_t winStart, uint16_t winSize);
     /**
      * Reset the window by clearing all the elements and setting winStart to the
      * given value.
      *
-     * \param winStart the window start
+     * @param winStart the window start
      */
     void Reset(uint16_t winStart);
     /**
      * Get the current winStart value.
      *
-     * \return the current winStart value
+     * @return the current winStart value
      */
     uint16_t GetWinStart() const;
     /**
      * Get the current winEnd value.
      *
-     * \return the current winEnd value
+     * @return the current winEnd value
      */
     uint16_t GetWinEnd() const;
     /**
      * Get the window size.
      *
-     * \return the window size
+     * @return the window size
      */
     std::size_t GetWinSize() const;
     /**
@@ -87,8 +87,8 @@
      * the current winStart. Note that the given distance must be less than the
      * window size.
      *
-     * \param distance the given distance
-     * \return a reference to the element in the window having the given distance
+     * @param distance the given distance
+     * @return a reference to the element in the window having the given distance
      *         from the current winStart
      */
     std::vector<bool>::reference At(std::size_t distance);
@@ -97,15 +97,15 @@
      * the current winStart. Note that the given distance must be less than the
      * window size.
      *
-     * \param distance the given distance
-     * \return a const reference to the element in the window having the given distance
+     * @param distance the given distance
+     * @return a const reference to the element in the window having the given distance
      *         from the current winStart
      */
     std::vector<bool>::const_reference At(std::size_t distance) const;
     /**
      * Advance the current winStart by the given number of positions.
      *
-     * \param count the number of positions the current winStart must be advanced by
+     * @param count the number of positions the current winStart must be advanced by
      */
     void Advance(std::size_t count);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/capability-information.cc ns-3.44/src/wifi/model/capability-information.cc
--- ns-3.43/src/wifi/model/capability-information.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/capability-information.cc	2025-03-09 16:55:49.783372600 -0700
@@ -54,6 +54,15 @@
     Set(2);
 }
 
+void
+CapabilityInformation::SetCriticalUpdate(bool flag)
+{
+    if (flag)
+    {
+        Set(6);
+    }
+}
+
 bool
 CapabilityInformation::IsEss() const
 {
@@ -84,6 +93,12 @@
     return Is(2);
 }
 
+bool
+CapabilityInformation::IsCriticalUpdate() const
+{
+    return Is(6);
+}
+
 void
 CapabilityInformation::Set(uint8_t n)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/capability-information.h ns-3.44/src/wifi/model/capability-information.h
--- ns-3.43/src/wifi/model/capability-information.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/capability-information.h	2025-03-09 16:55:49.783372600 -0700
@@ -15,7 +15,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * Capability information
  */
@@ -38,7 +38,7 @@
      * Set the short preamble bit
      * in the capability information field.
      *
-     * \param shortPreamble the short preamble bit
+     * @param shortPreamble the short preamble bit
      *
      */
     void SetShortPreamble(bool shortPreamble);
@@ -46,7 +46,7 @@
      * Set the short slot time bit
      * in the capability information field.
      *
-     * \param shortSlotTime the short preamble bit
+     * @param shortSlotTime the short preamble bit
      *
      */
     void SetShortSlotTime(bool shortSlotTime);
@@ -57,10 +57,16 @@
     void SetCfPollable();
 
     /**
+     * Set Critical Update flag (see IEEE 802.11be D5.0 9.4.1.4)
+     * @param flag critical update bit
+     */
+    void SetCriticalUpdate(bool flag);
+
+    /**
      * Check if the Extended Service Set (ESS) bit
      * in the capability information field is set to 1.
      *
-     * \return ESS bit in the capability information
+     * @return ESS bit in the capability information
      *         field is set to 1
      */
     bool IsEss() const;
@@ -68,7 +74,7 @@
      * Check if the Independent BSS (IBSS) bit
      * in the capability information field is set to 1.
      *
-     * \return IBSS bit in the capability information
+     * @return IBSS bit in the capability information
      *         field is set to 1
      */
     bool IsIbss() const;
@@ -76,7 +82,7 @@
      * Check if the short preamble bit
      * in the capability information field is set to 1.
      *
-     * \return short preamble bit in the capability information
+     * @return short preamble bit in the capability information
      *         field is set to 1
      */
     bool IsShortPreamble() const;
@@ -84,7 +90,7 @@
      * Check if the short slot time
      * in the capability information field is set to 1.
      *
-     * \return short slot time bit in the capability information
+     * @return short slot time bit in the capability information
      *         field is set to 1
      */
     bool IsShortSlotTime() const;
@@ -92,31 +98,38 @@
      * Check if the CF-Pollable bit
      * in the capability information field is set to 1.
      *
-     * \return CF-Pollable bit in the capability information
+     * @return CF-Pollable bit in the capability information
      *         field is set to 1
      */
     bool IsCfPollable() const;
 
     /**
+     * Check if Critical Update bit is set to 1
+     *
+     * @return true if set to 1, false otherwise
+     */
+    bool IsCriticalUpdate() const;
+
+    /**
      * Return the serialized size of capability
      * information.
      *
-     * \return the serialized size
+     * @return the serialized size
      */
     uint32_t GetSerializedSize() const;
     /**
      * Serialize capability information to the given buffer.
      *
-     * \param start an iterator to a buffer
-     * \return an iterator to a buffer after capability information
+     * @param start an iterator to a buffer
+     * @return an iterator to a buffer after capability information
      *         was serialized
      */
     Buffer::Iterator Serialize(Buffer::Iterator start) const;
     /**
      * Deserialize capability information from the given buffer.
      *
-     * \param start an iterator to a buffer
-     * \return an iterator to a buffer after capability information
+     * @param start an iterator to a buffer
+     * @return an iterator to a buffer after capability information
      *         was deserialized
      */
     Buffer::Iterator Deserialize(Buffer::Iterator start);
@@ -125,22 +138,22 @@
     /**
      * Check if bit n is set to 1.
      *
-     * \param n the bit position
+     * @param n the bit position
      *
-     * \return true if bit n is set to 1,
+     * @return true if bit n is set to 1,
      *         false otherwise
      */
     bool Is(uint8_t n) const;
     /**
      * Set bit n to 1.
      *
-     * \param n the bit position
+     * @param n the bit position
      */
     void Set(uint8_t n);
     /**
      * Set bit n to 0.
      *
-     * \param n the bit position
+     * @param n the bit position
      */
     void Clear(uint8_t n);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/channel-access-manager.cc ns-3.44/src/wifi/model/channel-access-manager.cc
--- ns-3.43/src/wifi/model/channel-access-manager.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/channel-access-manager.cc	2025-03-09 16:55:49.783372600 -0700
@@ -42,7 +42,7 @@
     /**
      * Create a PhyListener for the given ChannelAccessManager.
      *
-     * \param cam the ChannelAccessManager
+     * @param cam the ChannelAccessManager
      */
     PhyListener(ns3::ChannelAccessManager* cam)
         : m_cam(cam),
@@ -57,7 +57,7 @@
     /**
      * Set this listener to be active or not.
      *
-     * \param active whether this listener is active or not
+     * @param active whether this listener is active or not
      */
     void SetActive(bool active)
     {
@@ -65,7 +65,7 @@
     }
 
     /**
-     * \return whether this listener is active or not
+     * @return whether this listener is active or not
      */
     bool IsActive() const
     {
@@ -185,7 +185,20 @@
                           "and subsequently the medium becomes busy.",
                           BooleanValue(false),
                           MakeBooleanAccessor(&ChannelAccessManager::m_proactiveBackoff),
-                          MakeBooleanChecker());
+                          MakeBooleanChecker())
+            .AddAttribute("NSlotsLeft",
+                          "Fire the NSlotsLeftAlert trace source when the backoff counter with "
+                          "the minimum value among all ACs reaches this value or it is started "
+                          "with a value less than this attribute. If this value is zero, the "
+                          "trace source is never fired.",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&ChannelAccessManager::m_nSlotsLeft),
+                          MakeUintegerChecker<uint8_t>())
+            .AddTraceSource("NSlotsLeftAlert",
+                            "The backoff counter of the AC with the given index reached the "
+                            "threshold set through the NSlotsLeft attribute.",
+                            MakeTraceSourceAccessor(&ChannelAccessManager::m_nSlotsLeftCallback),
+                            "ns3::ChannelAccessManager::NSlotsLeftCallback");
     return tid;
 }
 
@@ -264,6 +277,11 @@
     {
         phyListener = std::make_shared<PhyListener>(this);
         m_phyListeners.emplace(phy, phyListener);
+        if (!m_phy)
+        {
+            // no PHY operating on this link and no previous PHY listener to reactivate
+            m_lastSwitchingEnd = Simulator::Now();
+        }
     }
     if (m_phy)
     {
@@ -272,12 +290,6 @@
     m_phy = phy; // this is the new active PHY
     ResizeLastBusyStructs();
     phy->RegisterListener(phyListener);
-    if (phy->IsStateSwitching())
-    {
-        auto duration = phy->GetDelayUntilIdle();
-        NS_LOG_DEBUG("switching start for " << duration);
-        m_lastSwitchingEnd = Simulator::Now() + duration;
-    }
 }
 
 void
@@ -370,9 +382,10 @@
     m_lastBusyEnd.emplace(WIFI_CHANLIST_PRIMARY, now);
     m_lastIdle.emplace(WIFI_CHANLIST_PRIMARY, Timespan{now, now});
 
-    const auto width = m_phy ? m_phy->GetChannelWidth() : 0;
-    std::size_t size =
-        (width > 20 && m_phy->GetStandard() >= WIFI_STANDARD_80211ax) ? width / 20 : 0;
+    const auto width = m_phy ? m_phy->GetChannelWidth() : MHz_u{0};
+    std::size_t size = (width > MHz_u{20} && m_phy->GetStandard() >= WIFI_STANDARD_80211ax)
+                           ? Count20MHzSubchannels(width)
+                           : 0;
     m_lastPer20MHzBusyEnd.resize(size, now);
 
     if (!m_phy || !m_phy->GetOperatingChannel().IsOfdm())
@@ -380,7 +393,7 @@
         return;
     }
 
-    if (width >= 40)
+    if (width >= MHz_u{40})
     {
         m_lastBusyEnd.emplace(WIFI_CHANLIST_SECONDARY, now);
         m_lastIdle.emplace(WIFI_CHANLIST_SECONDARY, Timespan{now, now});
@@ -391,7 +404,7 @@
         m_lastIdle.erase(WIFI_CHANLIST_SECONDARY);
     }
 
-    if (width >= 80)
+    if (width >= MHz_u{80})
     {
         m_lastBusyEnd.emplace(WIFI_CHANLIST_SECONDARY40, now);
         m_lastIdle.emplace(WIFI_CHANLIST_SECONDARY40, Timespan{now, now});
@@ -402,7 +415,7 @@
         m_lastIdle.erase(WIFI_CHANLIST_SECONDARY40);
     }
 
-    if (width >= 160)
+    if (width >= MHz_u{160})
     {
         m_lastBusyEnd.emplace(WIFI_CHANLIST_SECONDARY80, now);
         m_lastIdle.emplace(WIFI_CHANLIST_SECONDARY80, Timespan{now, now});
@@ -607,9 +620,10 @@
             auto interval = (m_phy->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ)
                                 ? GetSifs() + 2 * GetSlot()
                                 : m_phy->GetPifs();
-            auto width = (m_phy->GetOperatingChannel().IsOfdm() && m_phy->GetChannelWidth() > 20)
-                             ? GetLargestIdlePrimaryChannel(interval, now)
-                             : m_phy->GetChannelWidth();
+            auto width =
+                (m_phy->GetOperatingChannel().IsOfdm() && m_phy->GetChannelWidth() > MHz_u{20})
+                    ? GetLargestIdlePrimaryChannel(interval, now)
+                    : m_phy->GetChannelWidth();
             if (m_feManager->StartTransmission(txop, width))
             {
                 for (auto& collidingTxop : internalCollisionTxops)
@@ -710,6 +724,12 @@
     return backoffEnd;
 }
 
+Time
+ChannelAccessManager::GetNavEnd() const
+{
+    return m_lastNavEnd;
+}
+
 void
 ChannelAccessManager::UpdateBackoff()
 {
@@ -754,26 +774,43 @@
      * Is there a Txop which needs to access the medium, and,
      * if there is one, how many slots for AIFS+backoff does it require ?
      */
-    bool accessTimeoutNeeded = false;
+    Ptr<Txop> nextTxop;
     auto expectedBackoffEnd = Simulator::GetMaximumSimulationTime();
     const auto accessGrantStart = GetAccessGrantStart();
+    const auto now = Simulator::Now();
     for (auto txop : m_txops)
     {
         if (txop->GetAccessStatus(m_linkId) == Txop::REQUESTED)
         {
-            Time tmp = GetBackoffEndFor(txop, accessGrantStart);
-            if (tmp > Simulator::Now())
+            if (auto backoffEnd = GetBackoffEndFor(txop, accessGrantStart);
+                backoffEnd > now && backoffEnd < expectedBackoffEnd)
             {
-                accessTimeoutNeeded = true;
-                expectedBackoffEnd = std::min(expectedBackoffEnd, tmp);
+                expectedBackoffEnd = backoffEnd;
+                nextTxop = txop;
             }
         }
     }
-    NS_LOG_DEBUG("Access timeout needed: " << accessTimeoutNeeded);
-    if (accessTimeoutNeeded)
+    NS_LOG_DEBUG("Access timeout needed: " << (nextTxop != nullptr));
+    if (nextTxop)
     {
-        NS_LOG_DEBUG("expected backoff end=" << expectedBackoffEnd);
-        Time expectedBackoffDelay = expectedBackoffEnd - Simulator::Now();
+        const auto aci = nextTxop->GetWifiMacQueue()->GetAc();
+        NS_LOG_DEBUG("expected backoff end=" << expectedBackoffEnd << " by " << aci);
+        auto expectedBackoffDelay = expectedBackoffEnd - now;
+
+        if (m_nSlotsLeft > 0)
+        {
+            if (const auto slots = m_nSlotsLeft * GetSlot(); expectedBackoffDelay > slots)
+            {
+                // make the timer expire when the specified number of slots are left
+                expectedBackoffDelay -= slots;
+            }
+            else
+            {
+                // notify that a number of slots less than or equal to the specified value are left
+                m_nSlotsLeftCallback(m_linkId, aci, expectedBackoffDelay);
+            }
+        }
+
         if (m_accessTimeout.IsPending() &&
             Simulator::GetDelayLeft(m_accessTimeout) > expectedBackoffDelay)
         {
@@ -803,7 +840,7 @@
     // also be called before starting a TXOP gained through EDCA.
     UpdateLastIdlePeriod();
 
-    MHz_u width = 0;
+    MHz_u width{0};
 
     // we iterate over the different types of channels in the same order as they
     // are listed in WifiChannelListType
@@ -812,7 +849,7 @@
         if (lastIdle.second.start <= end - interval && lastIdle.second.end >= end)
         {
             // channel idle, update width
-            width = (width == 0) ? 20 : (2 * width);
+            width = (width == MHz_u{0}) ? MHz_u{20} : (2 * width);
         }
         else
         {
@@ -827,7 +864,7 @@
 {
     const auto now = Simulator::Now();
 
-    if (m_phy->GetChannelWidth() < 40)
+    if (m_phy->GetChannelWidth() < MHz_u{40})
     {
         NS_ASSERT_MSG(indices.size() == 1 && *indices.cbegin() == 0,
                       "Index 0 only can be specified if the channel width is less than 40 MHz");
